## qemu-kvm 0.14.1+noroms

=== Makefile ===
# Makefile for QEMU.

GENERATED_HEADERS = config-host.h trace.h qemu-options.def
ifeq ($(TRACE_BACKEND),dtrace)
GENERATED_HEADERS += trace-dtrace.h
endif

ifneq ($(wildcard config-host.mak),)
# Put the all: rule here so that config-host.mak can contain dependencies.
all: build-all
include config-host.mak
include $(SRC_PATH)/rules.mak
config-host.mak: $(SRC_PATH)/configure
	@echo $@ is out-of-date, running configure
	@sed -n "/.*Configured with/s/[^:]*: //p" $@ | sh
else
config-host.mak:
	@echo "Please call configure before running make!"
	@exit 1
endif

# Don't try to regenerate Makefile or configure
# We don't generate any of them
Makefile: ;
configure: ;

.PHONY: all clean cscope distclean dvi html info install install-doc \
	pdf recurse-all speed tar tarbin test build-all

$(call set-vpath, $(SRC_PATH):$(SRC_PATH)/hw)

LIBS+=-lz $(LIBS_TOOLS)

ifdef BUILD_DOCS
DOCS=qemu-doc.html qemu-tech.html qemu.1 qemu-img.1 qemu-nbd.8 QMP/qmp-commands.txt
else
DOCS=
endif

SUBDIR_MAKEFLAGS=$(if $(V),,--no-print-directory)
SUBDIR_DEVICES_MAK=$(patsubst %, %/config-devices.mak, $(TARGET_DIRS))
SUBDIR_DEVICES_MAK_DEP=$(patsubst %, %/config-devices.mak.d, $(TARGET_DIRS))

config-all-devices.mak: $(SUBDIR_DEVICES_MAK)
	$(call quiet-command,cat $(SUBDIR_DEVICES_MAK) | grep =y | sort -u > $@,"  GEN   $@")

-include $(SUBDIR_DEVICES_MAK_DEP)

%/config-devices.mak: default-configs/%.mak
	$(call quiet-command,$(SHELL) $(SRC_PATH)/scripts/make_device_config.sh $@ $<, "  GEN   $@")
	@if test -f $@; then \
	  if cmp -s $@.old $@; then \
	    mv $@.tmp $@; \
	    cp -p $@ $@.old; \
	  else \
	    if test -f $@.old; then \
	      echo "WARNING: $@ (user modified) out of date.";\
	    else \
	      echo "WARNING: $@ out of date.";\
	    fi; \
	    echo "Run \"make defconfig\" to regenerate."; \
	    rm $@.tmp; \
	  fi; \
	 else \
	  mv $@.tmp $@; \
	  cp -p $@ $@.old; \
	 fi

defconfig:
	rm -f config-all-devices.mak $(SUBDIR_DEVICES_MAK)

-include config-all-devices.mak

build-all: $(DOCS) $(TOOLS) recurse-all

config-host.h: config-host.h-timestamp
config-host.h-timestamp: config-host.mak
qemu-options.def: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

SUBDIR_RULES=$(patsubst %,subdir-%, $(TARGET_DIRS))

subdir-%: $(GENERATED_HEADERS)
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C $* V="$(V)" TARGET_DIR="$*/" all,)

ifneq ($(wildcard config-host.mak),)
include $(SRC_PATH)/Makefile.objs
endif

$(common-obj-y): $(GENERATED_HEADERS)
$(filter %-softmmu,$(SUBDIR_RULES)): $(trace-obj-y) $(common-obj-y) subdir-libdis

$(filter %-user,$(SUBDIR_RULES)): $(GENERATED_HEADERS) $(trace-obj-y) subdir-libdis-user subdir-libuser

ROMSUBDIR_RULES=$(patsubst %,romsubdir-%, $(ROMS))
romsubdir-%:
	$(call quiet-command,$(MAKE) $(SUBDIR_MAKEFLAGS) -C pc-bios/$* V="$(V)" TARGET_DIR="$*/",)

ALL_SUBDIRS=$(TARGET_DIRS) $(patsubst %,pc-bios/%, $(ROMS))

recurse-all: $(SUBDIR_RULES) $(ROMSUBDIR_RULES)

audio/audio.o audio/fmodaudio.o: QEMU_CFLAGS += $(FMOD_CFLAGS)

QEMU_CFLAGS+=$(CURL_CFLAGS)

ui/cocoa.o: ui/cocoa.m

ui/sdl.o audio/sdlaudio.o ui/sdl_zoom.o baum.o: QEMU_CFLAGS += $(SDL_CFLAGS)

ui/vnc.o: QEMU_CFLAGS += $(VNC_TLS_CFLAGS)

bt-host.o: QEMU_CFLAGS += $(BLUEZ_CFLAGS)

ifeq ($(TRACE_BACKEND),dtrace)
trace.h: trace.h-timestamp trace-dtrace.h
else
trace.h: trace.h-timestamp
endif
trace.h-timestamp: $(SRC_PATH)/trace-events config-host.mak
	$(call quiet-command,sh $(SRC_PATH)/scripts/tracetool --$(TRACE_BACKEND) -h < $< > $@,"  GEN   trace.h")
	@cmp -s $@ trace.h || cp $@ trace.h

trace.c: trace.c-timestamp
trace.c-timestamp: $(SRC_PATH)/trace-events config-host.mak
	$(call quiet-command,sh $(SRC_PATH)/scripts/tracetool --$(TRACE_BACKEND) -c < $< > $@,"  GEN   trace.c")
	@cmp -s $@ trace.c || cp $@ trace.c

trace.o: trace.c $(GENERATED_HEADERS)

trace-dtrace.h: trace-dtrace.dtrace
	$(call quiet-command,dtrace -o $@ -h -s $<, "  GEN   trace-dtrace.h")

# Normal practice is to name DTrace probe file with a '.d' extension
# but that gets picked up by QEMU's Makefile as an external dependancy
# rule file. So we use '.dtrace' instead
trace-dtrace.dtrace: trace-dtrace.dtrace-timestamp
trace-dtrace.dtrace-timestamp: $(SRC_PATH)/trace-events config-host.mak
	$(call quiet-command,sh $(SRC_PATH)/scripts/tracetool --$(TRACE_BACKEND) -d < $< > $@,"  GEN   trace-dtrace.dtrace")
	@cmp -s $@ trace-dtrace.dtrace || cp $@ trace-dtrace.dtrace

trace-dtrace.o: trace-dtrace.dtrace $(GENERATED_HEADERS)
	$(call quiet-command,dtrace -o $@ -G -s $<, "  GEN trace-dtrace.o")

simpletrace.o: simpletrace.c $(GENERATED_HEADERS)

version.o: $(SRC_PATH)/version.rc config-host.mak
	$(call quiet-command,$(WINDRES) -I. -o $@ $<,"  RC    $(TARGET_DIR)$@")

version-obj-$(CONFIG_WIN32) += version.o
######################################################################

qemu-img.o: qemu-img-cmds.h
qemu-img.o qemu-tool.o qemu-nbd.o qemu-io.o cmd.o: $(GENERATED_HEADERS)

qemu-img$(EXESUF): qemu-img.o qemu-tool.o qemu-error.o $(oslib-obj-y) $(trace-obj-y) $(block-obj-y) $(qobject-obj-y) $(version-obj-y) qemu-timer-common.o

qemu-nbd$(EXESUF): qemu-nbd.o qemu-tool.o qemu-error.o $(oslib-obj-y) $(trace-obj-y) $(block-obj-y) $(qobject-obj-y) $(version-obj-y) qemu-timer-common.o

qemu-io$(EXESUF): qemu-io.o cmd.o qemu-tool.o qemu-error.o $(oslib-obj-y) $(trace-obj-y) $(block-obj-y) $(qobject-obj-y) $(version-obj-y) qemu-timer-common.o

qemu-img-cmds.h: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -h < $< > $@,"  GEN   $@")

check-qint.o check-qstring.o check-qdict.o check-qlist.o check-qfloat.o check-qjson.o: $(GENERATED_HEADERS)

CHECK_PROG_DEPS = qemu-malloc.o $(oslib-obj-y) $(trace-obj-y)

check-qint: check-qint.o qint.o $(CHECK_PROG_DEPS)
check-qstring: check-qstring.o qstring.o $(CHECK_PROG_DEPS)
check-qdict: check-qdict.o qdict.o qfloat.o qint.o qstring.o qbool.o qlist.o $(CHECK_PROG_DEPS)
check-qlist: check-qlist.o qlist.o qint.o $(CHECK_PROG_DEPS)
check-qfloat: check-qfloat.o qfloat.o $(CHECK_PROG_DEPS)
check-qjson: check-qjson.o qfloat.o qint.o qdict.o qstring.o qlist.o qbool.o qjson.o json-streamer.o json-lexer.o json-parser.o $(CHECK_PROG_DEPS)

clean:
# avoid old build problems by removing potentially incorrect old files
	rm -f config.mak op-i386.h opc-i386.h gen-op-i386.h op-arm.h opc-arm.h gen-op-arm.h
	rm -f qemu-options.def
	rm -f *.o *.d *.a $(TOOLS) TAGS cscope.* *.pod *~ */*~
	rm -f slirp/*.o slirp/*.d audio/*.o audio/*.d block/*.o block/*.d net/*.o net/*.d fsdev/*.o fsdev/*.d ui/*.o ui/*.d
	rm -f qemu-img-cmds.h
	rm -f trace.c trace.h trace.c-timestamp trace.h-timestamp
	rm -f trace-dtrace.dtrace trace-dtrace.dtrace-timestamp
	rm -f trace-dtrace.h trace-dtrace.h-timestamp
	$(MAKE) -C tests clean
	for d in $(ALL_SUBDIRS) libhw32 libhw64 libuser libdis libdis-user; do \
	if test -d $$d; then $(MAKE) -C $$d $@ || exit 1; fi; \
	rm -f $$d/qemu-options.def; \
        done

distclean: clean
	rm -f config-host.mak config-host.h* config-host.ld $(DOCS) qemu-options.texi qemu-img-cmds.texi qemu-monitor.texi
	rm -f config-all-devices.mak
	rm -f roms/seabios/config.mak roms/vgabios/config.mak
	rm -f qemu-doc.info qemu-doc.aux qemu-doc.cp qemu-doc.dvi qemu-doc.fn qemu-doc.info qemu-doc.ky qemu-doc.log qemu-doc.pdf qemu-doc.pg qemu-doc.toc qemu-doc.tp qemu-doc.vr
	rm -f qemu-tech.info qemu-tech.aux qemu-tech.cp qemu-tech.dvi qemu-tech.fn qemu-tech.info qemu-tech.ky qemu-tech.log qemu-tech.pdf qemu-tech.pg qemu-tech.toc qemu-tech.tp qemu-tech.vr
	for d in $(TARGET_DIRS) libhw32 libhw64 libuser libdis libdis-user; do \
	rm -rf $$d || exit 1 ; \
        done

KEYMAPS=da     en-gb  et  fr     fr-ch  is  lt  modifiers  no  pt-br  sv \
ar      de     en-us  fi  fr-be  hr     it  lv  nl         pl  ru     th \
common  de-ch  es     fo  fr-ca  hu     ja  mk  nl-be      pt  sl     tr

ifdef INSTALL_BLOBS
BLOBS=bios.bin vgabios.bin vgabios-cirrus.bin \
vgabios-stdvga.bin vgabios-vmware.bin vgabios-qxl.bin \
ppc_rom.bin openbios-sparc32 openbios-sparc64 openbios-ppc \
gpxe-eepro100-80861209.rom \
pxe-e1000.bin \
pxe-ne2k_pci.bin pxe-pcnet.bin \
pxe-rtl8139.bin pxe-virtio.bin \
bamboo.dtb petalogix-s3adsp1800.dtb \
multiboot.bin linuxboot.bin \
s390-zipl.rom
BLOBS += extboot.bin
BLOBS += vapic.bin
else
BLOBS=
endif

install-doc: $(DOCS)
	$(INSTALL_DIR) "$(DESTDIR)$(docdir)"
	$(INSTALL_DATA) qemu-doc.html  qemu-tech.html "$(DESTDIR)$(docdir)"
ifdef CONFIG_POSIX
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DATA) qemu.1 qemu-img.1 "$(DESTDIR)$(mandir)/man1"
	$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man8"
	$(INSTALL_DATA) qemu-nbd.8 "$(DESTDIR)$(mandir)/man8"
endif

install-sysconfig:
	$(INSTALL_DIR) "$(DESTDIR)$(sysconfdir)/qemu"
	$(INSTALL_DATA) $(SRC_PATH)/sysconfigs/target/target-x86_64.conf "$(DESTDIR)$(sysconfdir)/qemu"

install: all $(if $(BUILD_DOCS),install-doc) install-sysconfig
	$(INSTALL_DIR) "$(DESTDIR)$(bindir)"
ifneq ($(TOOLS),)
	$(INSTALL_PROG) $(STRIP_OPT) $(TOOLS) "$(DESTDIR)$(bindir)"
endif
ifneq ($(BLOBS),)
	$(INSTALL_DIR) "$(DESTDIR)$(datadir)"
	set -e; for x in $(BLOBS); do \
	    if [ -f $(SRC_PATH)/pc-bios/$$x ];then \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/$$x "$(DESTDIR)$(datadir)"; \
	    fi \
	    ; if [ -f pc-bios/optionrom/$$x ];then \
		$(INSTALL_DATA) pc-bios/optionrom/$$x "$(DESTDIR)$(datadir)"; \
	    fi \
	done
endif
	$(INSTALL_DIR) "$(DESTDIR)$(datadir)/keymaps"
	set -e; for x in $(KEYMAPS); do \
		$(INSTALL_DATA) $(SRC_PATH)/pc-bios/keymaps/$$x "$(DESTDIR)$(datadir)/keymaps"; \
	done
	for d in $(TARGET_DIRS); do \
	$(MAKE) -C $$d $@ || exit 1 ; \
        done

# various test targets
test speed: all
	$(MAKE) -C tests $@

.PHONY: TAGS
TAGS:
	find "$(SRC_PATH)" -name '*.[hc]' -print0 | xargs -0 etags

cscope:
	rm -f ./cscope.*
	find . -name "*.[ch]" -print | sed 's,^\./,,' > ./cscope.files
	cscope -b

# documentation
MAKEINFO=makeinfo
MAKEINFOFLAGS=--no-headers --no-split --number-sections
TEXIFLAG=$(if $(V),,--quiet)
%.dvi: %.texi
	$(call quiet-command,texi2dvi $(TEXIFLAG) -I . $<,"  GEN   $@")

%.html: %.texi
	$(call quiet-command,$(MAKEINFO) $(MAKEINFOFLAGS) --html $< -o $@, \
	"  GEN   $@")

%.info: %.texi
	$(call quiet-command,$(MAKEINFO) $< -o $@,"  GEN   $@")

%.pdf: %.texi
	$(call quiet-command,texi2pdf $(TEXIFLAG) -I . $<,"  GEN   $@")

qemu-options.texi: $(SRC_PATH)/qemu-options.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@,"  GEN   $@")

qemu-monitor.texi: $(SRC_PATH)/hmp-commands.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@,"  GEN   $@")

QMP/qmp-commands.txt: $(SRC_PATH)/qmp-commands.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -q < $< > $@,"  GEN   $@")

qemu-img-cmds.texi: $(SRC_PATH)/qemu-img-cmds.hx
	$(call quiet-command,sh $(SRC_PATH)/scripts/hxtool -t < $< > $@,"  GEN   $@")

qemu.1: qemu-doc.texi qemu-options.texi qemu-monitor.texi
	$(call quiet-command, \
	  perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu.pod && \
	  pod2man --section=1 --center=" " --release=" " qemu.pod > $@, \
	  "  GEN   $@")

qemu-img.1: qemu-img.texi qemu-img-cmds.texi
	$(call quiet-command, \
	  perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-img.pod && \
	  pod2man --section=1 --center=" " --release=" " qemu-img.pod > $@, \
	  "  GEN   $@")

qemu-nbd.8: qemu-nbd.texi
	$(call quiet-command, \
	  perl -Ww -- $(SRC_PATH)/scripts/texi2pod.pl $< qemu-nbd.pod && \
	  pod2man --section=8 --center=" " --release=" " qemu-nbd.pod > $@, \
	  "  GEN   $@")

dvi: qemu-doc.dvi qemu-tech.dvi
html: qemu-doc.html qemu-tech.html
info: qemu-doc.info qemu-tech.info
pdf: qemu-doc.pdf qemu-tech.pdf

qemu-doc.dvi qemu-doc.html qemu-doc.info qemu-doc.pdf: \
	qemu-img.texi qemu-nbd.texi qemu-options.texi \
	qemu-monitor.texi qemu-img-cmds.texi

VERSION ?= $(shell cat VERSION)
FILE = qemu-$(VERSION)

# tar release (use 'make -k tar' on a checkouted tree)
tar:
	rm -rf /tmp/$(FILE)
	cp -r . /tmp/$(FILE)
	cd /tmp && tar zcvf ~/$(FILE).tar.gz $(FILE) --exclude CVS --exclude .git --exclude .svn

## qemu-kvm 0.15.1+dfsg

=== debian/changelog ===
qemu-kvm (0.15.1+dfsg-1) unstable; urgency=low

  * new upstream bugfix release 0.15.1
  * refreshed debian/patches/04_use_etc_kvm_kvm-ifup.patch
  * added two-pieces fix for CVE-2011-3346:
    scsi-disk-commonize-iovec-creation-between-reads-and-writes-103b40f51e-CVE-2011-3346.diff
    scsi-disk-lazily-allocate-bounce-buffer-7285477ab1-CVE-2011-3346.diff
    backported from upstream (closes: #646118)
  * remove extra/default stuff from debian/gbp.conf
  * remove many unneeded build-dependencies from debian/control
  * bump Standards-Version to 3.9.2 (no changes needed)
  * add debhelper tags to qemu-kvm.{preinst,postrm} or else lintian complains
  * removed a typo in qemu-kvm.init that referenced /dev/.udev but
    in incorrect way so it never actually worked (Closes: #644324)
  * upload to unstable (closes: #645976)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 21 Oct 2011 17:06:43 +0400

qemu-kvm (0.15.0+dfsg-2) experimental; urgency=low

  * applied build-move-QEMU_INCLUDES-before-QEMU_CFLAGS-76dc3cf82c.diff
    from upstream (-stable) to fix build breakage with spice installed
  * add spice build-dependency (libspice-server-dev and libspice-protocol-dev)
  * disable guest-agent for now, it needs to go into separate package

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 30 Aug 2011 00:07:30 +0400

qemu-kvm (0.15.0+dfsg-1) experimental; urgency=low

  * Build-Depend on librbd-dev (in addition to librados-dev)
  * update to 0.15.0 final release

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 10 Aug 2011 01:36:33 +0400

qemu-kvm (0.15.0~rc1+dfsg-1) experimental; urgency=low

  * new upstream (release candidate) (closes: #623858, #636105)
  * remove extra/default stuff from debian/gbp.conf
  * remove many unneeded build-dependencies from debian/control
  * bump Standards-Version to 3.9.2 (no changes needed)
  * add build-dependency on libglib2.0-dev
  * remove unneded patches, refresh needed patches, refresh pxe rom names
  * perform build in a build/ subdir for easier cleaning
  * set Maintainer: to me and add Jan Lübbe to Uploaders.
    Thank you Jan and Guido for all the hard work!

qemu-kvm (0.14.1+dfsg-4) unstable; urgency=low

  * switch from etherboot-qemu to ipxe (closes: #634040, #612775)
  * explicitly chown/chmod /dev/kvm in postinst if owned by root:root,
    for new installs when udev hasn't picked up new rules yet
    (closes: #607391)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 26 Jul 2011 11:13:42 +0400

qemu-kvm (0.14.1+dfsg-3) unstable; urgency=high

  * virtio-fix-indirect-descriptor-buffer-overflow-CVE-2011-2212
    fixes a guest-triggerable buffer overflow in virtio handling
    (closes: #632987)
  * os-posix-set-groups-properly-for--runas-CVE-2011-2527
    clears supplementary groups for -runas (closes: #633669)
  * two security updates so urgency is high

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 13 Jul 2011 00:59:47 +0400

qemu-kvm (0.14.1+dfsg-2) unstable; urgency=high

  * virtio: guard against negative vq notifies -- fixes a guest-triggerable
    bug in virtio implementation (CVE-2011-2512) (Closes: #631975)
    Urgency is high due to security fix.

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 29 Jun 2011 00:53:54 +0400

qemu-kvm (0.14.1+dfsg-1) unstable; urgency=low

  * new upstream 0.14.1 stable/bugfix release
    (closes: #616159, #624177)
  * remove vgabios package entirely finally, when it's properly
    packaged in debian (and depend on it) (Closes: #489442)
  * ship vgabios.bin link too, for now.  It's not used but helps for
    older versions of qemu-kvm.
  * add $(QEMU_KVM_CONFIGURE_OPTIONS) to ./configure flags, to simplify
    local/custom builds.  Does not affect Debian qemu-kvm build.
    Also fix whitespace in that area in debian/rules
  * move init.d script to rcS.d and don't run it on stop
    (Closes: #611952, #540686)
  * remove isa-bus:-Remove-bogus-IRQ-sharing-check-ee951a.diff
    (upstream)
  * build-depend on librados-dev to enable rbd support
  * update kvm-ifup to be a bit more accurate and to warn about
    problem cases.  (closes: #619300, #624006)
  * ignore-pci-unplug-requests-for-unpluggable-devices-CVE-2011-1751.diff
    (closes: #627448)
  * fix-crash-in-migration-32-bit-userspace-on-64-bit-host-51b0c6065a.diff
    (closes: #625571)
  * set-$SDL_VIDEODRIVER=x11-on-Linux-to-prevent-sudo-kvm-from-fighting-for-video-1de9756b97
    (closes: #604844)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 28 May 2011 13:43:40 +0400

qemu-kvm (0.14.0+dfsg-1~tls) unstable; urgency=low

  * 0.14.0 release:
   - much improved vga speed (closes: #575720, #574988)
   - other bugs (closes: #574063, #603424, #604034)
  * removed a ton of old patches that went upstream
  * refreshed some patches to apply cleanly to new code
  * introduced vgabios (0.6c+ca056d8e77) patch and use that
    instead of kvm/vgabios/.  Now we can use separate vgabios package
    (bios files changed. Now we don't ship vgabios.bin anymore)
  * added fix-configure-bin-symlinks.patch to fix ./configure in
    case all blobs in the source are removed
  * don't ship kvmtrace anymore (does not exist upstream?)
  * update debian/rules for the new package layout (esp. "clean" target)
  * enable hda (guest) audio device
  * apply isa-bus:-Remove-bogus-IRQ-sharing-check-ee951a.diff
    from upstream. this makes >4 com ports usable again
    (also removes old isa-refine-irq-reservations.patch)
  * use external seabios package and depend on it (>> 0.6.1.2)
  * move bridge-utils and iproute from Depends to Recommends
  * build-depend on xfslibs-dev (for xfs-specific ioctls, not for the library)
  * switch to 3.0 (quilt) format (and remove clean-patched target)
  * removed 06_no_system_linux_kvm_h.patch (kvm/* isn't used anymore)
  * depend on qemu-utils >> 0.14, and deprecate kvm-img, kvm-nbd and kvm-io
    (provide script wrappers for them that prints a warning and executes a
    real tool from qemu-utils)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 23 Feb 2011 13:40:53 +0300



=== debian/control ===
Source: qemu-kvm
Section: misc
Priority: optional
Maintainer: Michael Tokarev <mjt@tls.msk.ru>
Uploaders: Guido Günther <agx@sigxcpu.org>, Jan Lübbe <jluebbe@debian.org>
Build-Depends: debhelper (>= 7.2.3~), pkg-config, texinfo, python,
 uuid-dev, zlib1g-dev, libsdl1.2-dev, libasound2-dev, libcurl4-gnutls-dev,
 libgnutls-dev, libncurses5-dev, libvdeplug2-dev, libpulse-dev, libbluetooth-dev,
 libbrlapi-dev, libpci-dev, libsasl2-dev, libattr1-dev, xfslibs-dev,
 libaio-dev,
 linux-libc-dev (>= 2.6.32),
 librados-dev, librbd-dev,
 libspice-protocol-dev, libspice-server-dev (>> 0.8.2-1),
 libglib2.0-dev
Standards-Version: 3.9.2.0
Homepage: http://www.linux-kvm.org/
Vcs-Browser: http://git.debian.org/?p=collab-maint/qemu-kvm.git
Vcs-Git: git://git.debian.org/git/collab-maint/qemu-kvm.git

Package: qemu-kvm
Architecture: i386 amd64
Pre-Depends: adduser
Depends: ${shlibs:Depends}, ${misc:Depends}, python,
 seabios (>> 0.6.1.2), vgabios (>= 0.6c-3),
 qemu-keymaps, qemu-utils (>> 0.14.0), ipxe
Recommends: bridge-utils, iproute
Suggests: debootstrap, vde2, samba
Provides: kvm
Conflicts: kvm-source (<= 18-1), kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
Replaces: kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
Description: Full virtualization on x86 hardware
 Using KVM, one can run multiple virtual PCs, each running unmodified Linux or
 Windows images. Each virtual machine has private virtualized hardware: a
 network card, disk, graphics adapter, etc. 
 .
 KVM (for Kernel-based Virtual Machine) is a full virtualization solution for
 Linux hosts on x86 hardware with x86 guests. KVM is intended for systems where
 the processor has hardware support for virtualization, see below for details.
 All combinations of 32-bit and 64-bit host and guest systems are supported,
 except 64-bit guests on 32-bit hosts.
 .
 KVM requires your system to support hardware virtualization, provided by AMD's
 SVM capability or Intel's VT. See /usr/share/doc/qemu-kvm/README.Debian for
 more information.

Package: qemu-kvm-dbg
Architecture: i386 amd64
Section: debug
Depends: ${misc:Depends}, qemu-kvm (= ${binary:Version})
Conflicts: kvm-dbg
Replaces: kvm-dbg
Priority: extra
Description: Debugging info for qemu-kvm
 This package contains the debugging symbols for qemu-kvm.

Package: kvm
Architecture: i386 amd64
Depends: ${misc:Depends}, qemu-kvm
Section: oldlibs
Priority: extra
Description: dummy transitional package from kvm to qemu-kvm
 This transitional package helps users transition from the kvm package to the
 kvm-qemu package.  Once this package and its dependencies are installed you
 can safely remove it.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper. 
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# where all bios and other support files are installed
bdir := /usr/share/kvm
tdir := debian/qemu-kvm
tbdir := ${tdir}$(bdir)

# where various other packages keeps their data files
ipxe := /usr/lib/ipxe
seabios := /usr/share/seabios
vgabios := /usr/share/vgabios

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
BASE_ARCH := $(DEB_BUILD_ARCH)
QEMU_ARCH := $(BASE_ARCH)

ifeq (i386,$(DEB_BUILD_ARCH))
	BASE_ARCH := x86
	QEMU_ARCH := i386
endif
ifeq (amd64,$(DEB_BUILD_ARCH))
	BASE_ARCH := x86
	QEMU_ARCH := x86_64
endif
ifeq (x86,$(BASE_ARCH))
	QEMU_TARGET = x86_64-softmmu
	QEMU_EXE = $(QEMU_TARGET)/qemu-system-x86_64
endif

ifeq (powerpc,$(DEB_BUILD_ARCH))
	QEMU_TARGET = XXXfixme
	QEMU_EXE = $(QEMU_TAEGET)/qemu-system-ppcemb
endif

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

# make build the default target
build:

config: build/config-host.mak
build/config-host.mak: configure
	dh_testdir
	mkdir -p build/
	cd build && ../configure --prefix=/usr \
		    --datadir=${bdir} \
		    --sysconfdir=/etc \
		    --audio-drv-list="alsa oss sdl pa" \
		    --audio-card-list="ac97 es1370 sb16 cs4231a adlib gus hda" \
		    --disable-strip \
		    --disable-xen \
		    --disable-blobs \
		    --disable-guest-agent \
		    $(QEMU_KVM_CONFIGURE_OPTIONS)
	cat build/config-host.mak

build: build/build-stamp
build/build-stamp: build/config-host.mak
	dh_testdir

# main executable and support tools
	$(MAKE) -C build/ ROMS=

# arch-specific stuff

ifeq (powerpc,$(BASE_ARCH))
	$(MAKE) -C build/pc-bios bamboo.dtd
endif

	touch $@

clean:
	dh_testdir
	rm -rf build/
	# clean up upstream leftovers
	rm -f scripts/*.pyc
	dh_clean

install: build/install-stamp
build/install-stamp: build/build-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

# qemu builds only a few files and we will rename them all anyway,
# so install it all here manually.

	install -Dp build/$(QEMU_EXE) ${tdir}/usr/bin/kvm
	install -Dp build/qemu.1 ${tdir}/usr/share/man/man1/kvm.1
	sed 's|@@|img|g' debian/kvm-utils.run > ${tdir}/usr/bin/kvm-img
	sed 's|@@|nbd|g' debian/kvm-utils.run > ${tdir}/usr/bin/kvm-nbd
	sed 's|@@|io|g'  debian/kvm-utils.run > ${tdir}/usr/bin/kvm-io
	chmod 0755 ${tdir}/usr/bin/kvm-*
	dh_installman debian/kvm-img.1 debian/kvm-nbd.8

	install -Dp -m 0755 debian/kvm-ifup ${tdir}/etc/kvm/kvm-ifup
	install -Dp -m 0755 debian/kvm-ifdown ${tdir}/etc/kvm/kvm-ifdown

	# Install the userspace utilities
	install -m 0755 kvm/kvm_stat ${tdir}/usr/bin/

# use keymaps from qemu-keymaps package
	dh_link /usr/share/qemu/keymaps ${bdir}/keymaps

ifeq (x86,$(BASE_ARCH))

	# link appropriate bios files from seabios package
	dh_link ${seabios}/bios.bin ${bdir}/bios.bin \
	  ${seabios}/optionrom/extboot.bin ${bdir}/extboot.bin \
	  ${seabios}/optionrom/linuxboot.bin ${bdir}/linuxboot.bin \
	  ${seabios}/optionrom/multiboot.bin ${bdir}/multiboot.bin \
	  ${seabios}/optionrom/vapic.bin ${bdir}/vapic.bin \

	# link to vgabios files and vgabios.bin too, for now
	dh_link \
	  ${vgabios}/vgabios.cirrus.bin ${bdir}/vgabios-cirrus.bin \
	  ${vgabios}/vgabios.stdvga.bin ${bdir}/vgabios-stdvga.bin \
	  ${vgabios}/vgabios.vmware.bin ${bdir}/vgabios-vmware.bin \
	  ${vgabios}/vgabios.qxl.bin ${bdir}/vgabios-qxl.bin \
	  ${vgabios}/vgabios.bin ${bdir}/vgabios.bin

# pxe roms are x86-specific.  package ipxe.
	dh_link \
	 $(ipxe)/e1000_82540.rom $(bdir)/pxe-e1000.rom \
	 $(ipxe)/eepro100.rom $(bdir)/pxe-eepro100.rom \
	 $(ipxe)/ne2k_isa.rom $(bdir)/pxe-ne2k_isa.rom \
	 $(ipxe)/ns8390.rom $(bdir)/pxe-ne2k_pci.rom \
	 $(ipxe)/pcnet32.rom $(bdir)/pxe-pcnet.rom \
	 $(ipxe)/rtl8139.rom $(bdir)/pxe-rtl8139.rom \
	 $(ipxe)/virtio-net.rom $(bdir)/pxe-virtio.rom \

endif

ifeq (powerpc,$(BASE_ARCH))
	cp build/pc-bios/bamboo.dtd ${tbdir}/bamboo.dtd
endif

	touch $@

binary-indep:

binary-arch: build/install-stamp
	dh_testdir -s
	dh_testroot -s
#	dh_installdebconf -s
	dh_installdocs -a build/qemu-doc.html build/qemu-tech.html \
		docs/*.txt docs/specs
#	dh_installexamples -s
#	dh_installmenu -s
#	dh_installlogrotate -s
#	dh_installemacsen -s
#	dh_installpam -s
#	dh_installmime -s
	dh_installudev
	dh_installinit -s --noscripts
#	dh_installcron -s
#	dh_installinfo -s
	dh_bugfiles
	dh_installchangelogs
	dh_strip -s --dbg-package=qemu-kvm-dbg
	dh_lintian
	dh_link -s
	dh_compress -s
	dh_fixperms -s
#	dh_makeshlibs -s
	dh_installdeb -s
#	dh_perl -s
	dh_shlibdeps -s
	dh_gencontrol -s -Nkvm
	dh_gencontrol -pkvm -- -v1:$(DEB_VERSION)
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch

# get-orig-source adapted from /usr/share/gnome-pkg-tools/1/rules/sf-get-source.mk from the gnome-pkg-tools package
# copied from CDBS' buildvars
DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/+[^-]*-[^-]*$$//')

# where to store the resulting .orig tarball
DEB_TARBALL_DOWNLOAD_DIR ?= ../tarballs
TARBALL_EXT ?= tar.gz

#SF_PROJECT ?= $(DEB_SOURCE_PACKAGE)
SF_PROJECT = kvm
SF_MODULE ?= $(DEB_SOURCE_PACKAGE)
SF_TARBALL ?= $(SF_MODULE)-$(DEB_UPSTREAM_VERSION).$(TARBALL_EXT)
SF_DOWNLOAD_URL ?= http://$$sf_mirror.dl.sourceforge.net/$(SF_PROJECT)/$(SF_TARBALL)
SF_MIRRORS ?= dfn heanet internap jaist kent mesh nchc ovh puzzle superb-east superb-west surfnet switch ufpr waix
SF_TARBALL_DESTINATION = $(DEB_TARBALL_DOWNLOAD_DIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.$(TARBALL_EXT)
SF_DOWNLOAD_COMMAND ?= for sf_mirror in $(SF_MIRRORS); do wget -nv -T10 -t1 -O $(SF_TARBALL_DESTINATION).tmp $(SF_DOWNLOAD_URL) && break; done

get-orig-tarball: $(SF_TARBALL_DESTINATION)
$(SF_TARBALL_DESTINATION):
	dh_testdir
	@@echo 'Source package:                      $(DEB_SOURCE_PACKAGE)'
	@@echo 'Source package:                      $(DEB_VERSION)'
	@@echo 'Source version without epoch:        $(DEB_NOEPOCH_VERSION)'
	@@echo 'Upstream version (for orig tarball): $(DEB_UPSTREAM_VERSION)'
	mkdir -p $(DEB_TARBALL_DOWNLOAD_DIR)
	$(SF_DOWNLOAD_COMMAND)
	mv $(SF_TARBALL_DESTINATION).tmp $(SF_TARBALL_DESTINATION)

get-orig-source: $(SF_TARBALL_DESTINATION)
	case "$(TARBALL_EXT)" in \
	tar.bz2|tbz) \
	  bzcat $(DEB_TARBALL_DOWNLOAD_DIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.$(TARBALL_EXT) | \
	  gzip -9 >$(DEB_TARBALL_DOWNLOAD_DIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz ; \
	  rm -f $(DEB_TARBALL_DOWNLOAD_DIR)/$(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.$(TARBALL_EXT) \
	  ;;\
	esac
	cd $(DEB_TARBALL_DOWNLOAD_DIR) && \
	  tar xzf $(DEB_SOURCE_PACKAGE)_$(DEB_UPSTREAM_VERSION).orig.tar.gz
	cd $(DEB_TARBALL_DOWNLOAD_DIR)/$(DEB_SOURCE_PACKAGE)-$(DEB_UPSTREAM_VERSION) && \
	  rm -f \
		pc-bios/*.bin \
		pc-bios/*.rom \
		pc-bios/openbios-* \
		pc-bios/*.dtb \
		pc-bios/video.x \
		pc-bios/optionrom/*.bin \
		.git?*
	cd $(DEB_TARBALL_DOWNLOAD_DIR) && \

## qemu-kvm 1.0+dfsg

=== debian/changelog ===
qemu-kvm (1.0+dfsg-9) unstable; urgency=low

  * fix ipxe dependency (Closes: #659010, #585170)
  * fix CFLAGS=`` construct to use $(shell ) instead
    (chokes on older make, see #660133)
  * stop shipping 05_report_debian_package_version.patch
    and use --with-pkgversion configure option instead
  * depend on vgabios >= 0.6c-3~ not 0.6c-3, to assist backporting
  * apply qemu-1.0.1.diff -- difference from qemu 1.0 to qemu 1.0.1
    from git, except of version change (this includes CVE-2012-0029 fix)

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 27 Feb 2012 23:47:59 +0400

qemu-kvm (1.0+dfsg-8) unstable; urgency=low

  * Depends on ipxe-qemu or old ipxe (Closes: #658853, #585170)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 07 Feb 2012 00:59:20 +0400

qemu-kvm (1.0+dfsg-7) unstable; urgency=low

  * Force-enable optional features in ./configure args which are listed
    as build-dependencies, in order to catch things like broken
    dependency which makes corresponding optional feature to be omitted.
    (Closes: #658169)
    Placed all optional features into debian/optional-features file
    instead of hardcoding them in debian/rules, to be able to comment
    on each of them.
    Also rearrange build-deps and sort them alphabetically.
  * Removed debian/gbp.conf (unused)
  * Converted debian/rules to use dh.  Set debian/compat to 8 (and build-depend
    on debhelper >= 8).  This also fixes lintian warnings about missing targets.
  * Added two patches for manpage generation to recognize/use UTF8.
    (Closes: #655911)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 02 Feb 2012 12:45:28 +0400

qemu-kvm (1.0+dfsg-6) unstable; urgency=high

  [ Michael Tokarev ]
  * patch fix-vnc-memory-corruption-with-width=1440.diff from
    Gerd Hoffman, fixing guest-triggerable memory corruption
    in vnc with one of standard display sizes (1440x1050 or
    1440x900 or others -- these can be set by guest if run
    with -vga {std|vmware}.  Closes: #608756.
  * Build-depend on libvdeplug-dev | libvdeplug2-dev, not just
    libvdeplug2-dev, to cope with the package rename (#658082)
  * Urgency is high again to help previous security fix to enter
    wheezy (which has stalled due to #658082 above)

  [ Moritz Muehlenhoff ]
  * enable usage of dpkg-buildflags for CFLAGS and LDFLAGS
    (this enables hardened build too)  (Closes: #657867)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 31 Jan 2012 13:09:16 +0400

qemu-kvm (1.0+dfsg-5) unstable; urgency=high

  * urgency high due to security fix
  * e1000-bounds-packet-size-against-buffer-size-CVE-2012-0029.diff
    patch from upstream to fix CVE-2012-0029 (Closes: #657529)

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 27 Jan 2012 00:42:11 +0400

qemu-kvm (1.0+dfsg-4) unstable; urgency=low

  * added Breaks: libvirt0 (<< 0.9.8-2~) since older versions did not
    parse 1.0 version number corrrectly (Closes: #655024)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 19 Jan 2012 19:20:18 +0400

qemu-kvm (1.0+dfsg-3) unstable; urgency=low

  * ship /etc/kvm/target-x86_64.conf (Closes: #652281)
  * resurrect extboot support which has been removed in qemu-kvm 1.0
    (debian/patches/resurrect-extboot.diff).  (Closes: #652447)
  * build-depend on libiscsi-dev (which has been packaged for Debian
    a few days ago) to enable iscsi support

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 17 Dec 2011 15:03:20 +0400

qemu-kvm (1.0+dfsg-2) unstable; urgency=low

  * mention: (closes: #647312)
    for 1.0 upload
  * upload to unstable

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 16 Dec 2011 12:12:38 +0400

qemu-kvm (1.0+dfsg-1) experimental; urgency=low

  * new upstream release (1.0) (Closes: #624070, #647312)
  * removed obsolete patches, refreshed old patches
  * --disable-smartcard-nss && --disable-smartcard - the
    linkage requiriments (nspr) is too heavy and the link/library
    needs some work still (linking to too many unused libs)
  * require seabios >>1.6.3 (Closes: #648853)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 04 Dec 2011 19:26:40 +0400

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,29 @@
 Priority: optional
 Maintainer: Michael Tokarev <mjt@tls.msk.ru>
 Uploaders: Guido Günther <agx@sigxcpu.org>, Jan Lübbe <jluebbe@debian.org>
-Build-Depends: debhelper (>= 7.2.3~), pkg-config, texinfo, python,
- uuid-dev, zlib1g-dev, libsdl1.2-dev, libasound2-dev, libcurl4-gnutls-dev,
- libgnutls-dev, libncurses5-dev, libvdeplug2-dev, libpulse-dev, libbluetooth-dev,
- libbrlapi-dev, libpci-dev, libsasl2-dev, libattr1-dev, xfslibs-dev,
+Build-Depends: debhelper (>= 8), pkg-config, texinfo, python,
  libaio-dev,
+ libasound2-dev, 
+ libattr1-dev, 
+ libbluetooth-dev,
+ libbrlapi-dev, 
+ libcurl4-gnutls-dev,
+ libglib2.0-dev,
+ libgnutls-dev, 
+ libiscsi-dev,
+ libncurses5-dev, 
+ libpci-dev, 
+ libpulse-dev, 
+ librados-dev, librbd-dev,
+ libsasl2-dev, 
+ libsdl1.2-dev, 
+ libspice-protocol-dev, 
+ libspice-server-dev (>> 0.8.2-1),
+ libvdeplug-dev | libvdeplug2-dev,
  linux-libc-dev (>= 2.6.32),
- librados-dev, librbd-dev,
- libspice-protocol-dev, libspice-server-dev (>> 0.8.2-1),
- libglib2.0-dev
+ uuid-dev, 
+ xfslibs-dev,
+ zlib1g-dev
 Standards-Version: 3.9.2.0
 Homepage: http://www.linux-kvm.org/
 Vcs-Browser: http://git.debian.org/?p=collab-maint/qemu-kvm.git
@@ -21,12 +35,14 @@
 Architecture: i386 amd64
 Pre-Depends: adduser
 Depends: ${shlibs:Depends}, ${misc:Depends}, python,
- seabios (>> 0.6.1.2), vgabios (>= 0.6c-3),
- qemu-keymaps, qemu-utils (>> 0.14.0), ipxe
+ seabios (>> 1.6.3), vgabios (>= 0.6c-3~),
+ qemu-keymaps, qemu-utils (>> 0.14.0),
+ ipxe-qemu | ipxe (<< 1.0.0+git-20120202.f6840ba-2)
 Recommends: bridge-utils, iproute
 Suggests: debootstrap, vde2, samba
 Provides: kvm
 Conflicts: kvm-source (<= 18-1), kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
+Breaks: libvirt0 (<< 0.9.8-2~)
 Replaces: kvm-data (<= 66+dfsg-1.1), kvm (<< 1:0)
 Description: Full virtualization on x86 hardware
  Using KVM, one can run multiple virtual PCs, each running unmodified Linux or

=== debian/rules ===
--- 
+++ 
@@ -28,6 +28,7 @@
 DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 BASE_ARCH := $(DEB_BUILD_ARCH)
 QEMU_ARCH := $(BASE_ARCH)
+DEB_VERSION := $(shell sed -n -e 's/^[^(]* (\([^)]*\)) .*/\1/p' -e1q debian/changelog)
 
 ifeq (i386,$(DEB_BUILD_ARCH))
 	BASE_ARCH := x86
@@ -47,43 +48,43 @@
 	QEMU_EXE = $(QEMU_TAEGET)/qemu-system-ppcemb
 endif
 
-CFLAGS = -Wall -g
-
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
-else
-	CFLAGS += -O2
-endif
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    MAKEFLAGS += -j$(NUMJOBS)
-endif
-
-# make build the default target
-build:
-
-config: build/config-host.mak
-build/config-host.mak: configure
-	dh_testdir
+CFLAGS = $(shell dpkg-buildflags --get CFLAGS)
+CFLAGS += $(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS += -Wall
+LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
+
+#export DH_OPTIONS = --with=quilt --parallel
+
+.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep
+binary binary-arch binary-indep build build-arch build-indep clean install install-arch install-indep:
+# "+" in front of dh is to work around dh completely ignoring
+# --parallel and DEB_BUILD_OPTIONS=parallel=NN
+	+dh $@
+
+override_dh_auto_configure config:
 	mkdir -p build/
-	cd build && ../configure --prefix=/usr \
-		    --datadir=${bdir} \
-		    --sysconfdir=/etc \
-		    --audio-drv-list="alsa oss sdl pa" \
-		    --audio-card-list="ac97 es1370 sb16 cs4231a adlib gus hda" \
-		    --disable-strip \
-		    --disable-xen \
-		    --disable-blobs \
-		    --disable-guest-agent \
-		    $(QEMU_KVM_CONFIGURE_OPTIONS)
+	cd build && ../configure \
+		--with-pkgversion="Debian qemu-kvm $(DEB_VERSION)" \
+		--target-list=$(QEMU_TARGET) \
+		--prefix=/usr \
+		--datadir=${bdir} \
+		--sysconfdir=/etc \
+		--extra-cflags="$(CFLAGS)" \
+		--extra-ldflags="$(LDFLAGS)" \
+		--enable-kvm \
+		--disable-strip \
+		--disable-xen \
+		--disable-blobs \
+		--disable-guest-agent \
+		--audio-drv-list="alsa oss sdl pa" \
+		--audio-card-list="ac97 es1370 sb16 cs4231a adlib gus hda" \
+		`sed 's/#.*//' ../debian/optional-features` \
+		$(QEMU_KVM_CONFIGURE_OPTIONS)
 	cat build/config-host.mak
 
-build: build/build-stamp
-build/build-stamp: build/config-host.mak
-	dh_testdir
-
+override_dh_auto_build:
 # main executable and support tools
-	$(MAKE) -C build/ ROMS=
+	$(MAKE) -C build/ ROMS= TOOLS=
 
 # arch-specific stuff
 
@@ -91,25 +92,16 @@
 	$(MAKE) -C build/pc-bios bamboo.dtd
 endif
 
-	touch $@
-
-clean:
-	dh_testdir
+override_dh_auto_test:
+
+override_dh_auto_clean:
 	rm -rf build/
-	# clean up upstream leftovers
 	rm -f scripts/*.pyc
-	dh_clean
-
-install: build/install-stamp
-build/install-stamp: build/build-stamp
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs
+
+override_dh_auto_install:
 
 # qemu builds only a few files and we will rename them all anyway,
 # so install it all here manually.
-
 	install -Dp build/$(QEMU_EXE) ${tdir}/usr/bin/kvm
 	install -Dp build/qemu.1 ${tdir}/usr/share/man/man1/kvm.1
 	sed 's|@@|img|g' debian/kvm-utils.run > ${tdir}/usr/bin/kvm-img
@@ -154,49 +146,28 @@
 	 $(ipxe)/rtl8139.rom $(bdir)/pxe-rtl8139.rom \
 	 $(ipxe)/virtio-net.rom $(bdir)/pxe-virtio.rom \
 
+# x86 cpu definitions
+	install -Dp -m 0644 \
+	  sysconfigs/target/target-x86_64.conf \
+	  ${tdir}/etc/kvm/target-x86_64.conf
 endif
 
 ifeq (powerpc,$(BASE_ARCH))
 	cp build/pc-bios/bamboo.dtd ${tbdir}/bamboo.dtd
 endif
 
-	touch $@
-
-binary-indep:
-
-binary-arch: build/install-stamp
-	dh_testdir -s
-	dh_testroot -s
-#	dh_installdebconf -s
-	dh_installdocs -a build/qemu-doc.html build/qemu-tech.html \
-		docs/*.txt docs/specs
-#	dh_installexamples -s
-#	dh_installmenu -s
-#	dh_installlogrotate -s
-#	dh_installemacsen -s
-#	dh_installpam -s
-#	dh_installmime -s
-	dh_installudev
-	dh_installinit -s --noscripts
-#	dh_installcron -s
-#	dh_installinfo -s
-	dh_bugfiles
-	dh_installchangelogs
-	dh_strip -s --dbg-package=qemu-kvm-dbg
-	dh_lintian
-	dh_link -s
-	dh_compress -s
-	dh_fixperms -s
-#	dh_makeshlibs -s
-	dh_installdeb -s
-#	dh_perl -s
-	dh_shlibdeps -s
-	dh_gencontrol -s -Nkvm
+override_dh_installinit:
+	dh_installinit --noscripts
+
+override_dh_strip:
+	dh_strip --dbg-package=qemu-kvm-dbg
+
+override_dh_gencontrol:
+	dh_gencontrol -Nkvm
 	dh_gencontrol -pkvm -- -v1:$(DEB_VERSION)
-	dh_md5sums -s
-	dh_builddeb -s
-
-binary: binary-indep binary-arch
+
+.PHONY: config
+.PHONY: override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_clean override_dh_auto_install override_dh_installinit override_dh_strip override_dh_gencontrol
 
 # get-orig-source adapted from /usr/share/gnome-pkg-tools/1/rules/sf-get-source.mk from the gnome-pkg-tools package
 # copied from CDBS' buildvars
@@ -248,4 +219,3 @@
 		pc-bios/video.x \
 		pc-bios/optionrom/*.bin \
 		.git?*
-	cd $(DEB_TARBALL_DOWNLOAD_DIR) && \
